<?php
/*
Plugin Name: Ajax Spell Checker
Plugin URI: http://m0n5t3r.info/work/wordpress-plugins/ajax-spell-checker/
Description: Spell checker for Wordpress using Ajax.
Version: 0.1
Author: m0n5t3r
Author URI: http://m0n5t3r.info/
*/

//an array containing our option names and default values

function as_add_options_page(){
	$fs_path = dirname(__FILE__);
	$as_options = array(
		"as_personal"	=> "$fs_path/service/custom.en.pws",
		"as_repl"		=> "$fs_path/service/custom.en.prepl",
		"as_lang"		=> "en",
		"as_maxsug"		=> 5, 
		"as_runtogether"=> true
	);

	//make sure options exist
	foreach($as_options as $k => $v){
		if(get_option($k) === false){
			add_option($k, $v);
		}
	}

	add_options_page("Ajax Spell Checker Options","Spell Checker",5,"ajax_spellchecker/options.php");
}

function as_tinymce_plugin(&$plugins){
	$plugins[] = "../../../../wp-content/plugins/ajax_spellchecker/tinymce/mcespell";
	return $plugins;
}

function as_tinymce_button(&$buttons){
	$buttons[] = "mcespell";
	return $buttons;
}

function as_fix_tinymce_plugin(){
	global $plugins;
	$tmp = explode(",", $plugins);
	for($i = 0; $i < count($tmp); $i++){
		$tmp[$i] = basename($tmp[$i]);
	}
	$plugins = implode(",", $tmp);
}

function as_rewrite_rules($rules){
	$tmp = explode("\n",$rules);
	$ret = array();
	$ig_rules = "RewriteRule wp-includes/js/tinymce/plugins/mcespell/spell-check-service wp-content/plugins/ajax_spellchecker/service/spell-check-service.php [L]\n";
	$ig_rules .= 'RewriteRule wp-includes/js/tinymce/plugins/mcespell/(.*) wp-content/plugins/ajax_spellchecker/tinymce/mcespell/$1 [L]';
	foreach($tmp as $rule){
		array_push($ret, $rule);
		if(strstr($rule,"RewriteBase") !== false)
			array_push($ret, $ig_rules);
	}
	$rules = join("\n", $ret);
	return $rules;
}

add_action("admin_head","as_add_options_page");
add_action("mce_options","as_fix_tinymce_plugin");

add_filter("mce_plugins","as_tinymce_plugin");
add_filter("mce_buttons","as_tinymce_button");
add_filter("mod_rewrite_rules","as_rewrite_rules");
?>